package com.company.fsuggestion.web.screens.order;

import com.company.fsuggestion.entity.Customer;
import com.company.fsuggestion.web.screens.customer.CustomerEdit;
import com.haulmont.bali.util.ParamsMap;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.core.global.LoadContext;
import com.haulmont.cuba.gui.ScreenBuilders;
import com.haulmont.cuba.gui.components.SuggestionPickerField;
import com.haulmont.cuba.gui.components.actions.BaseAction;
import com.haulmont.cuba.gui.icons.CubaIcon;
import com.haulmont.cuba.gui.screen.*;
import com.company.fsuggestion.entity.Order;

import javax.inject.Inject;
import java.util.List;
import java.util.Map;

@UiController("fsuggestion_Order.edit")
@UiDescriptor("order-edit.xml")
@EditedEntityContainer("orderDc")
@LoadDataBeforeShow
public class OrderEdit extends StandardEditor<Order> {

    @Inject
    private SuggestionPickerField<Customer> customerField;

    @Inject
    private DataManager dataManager;

    @Inject
    private ScreenBuilders screenBuilders;

    private volatile String searchValue;

    @Subscribe
    public void onInit(InitEvent event) {
        customerField.addAction(new BaseAction("openEditor")
                .withIcon(CubaIcon.EDIT_ACTION.source())
                .withHandler(actionPerformedEvent -> {
                    CustomerEdit customerEditor = screenBuilders.editor(customerField)
                            .withScreenClass(CustomerEdit.class)
                            /*.withOptions(new MapScreenOptions(ParamsMap.of("searchValue", searchValue))) если использовать ScreenOptions */
                            .newEntity()
                            .build();


                    customerEditor.setSearchValue(searchValue);
                    customerEditor.show();
                }), 1);
    }


    @Install(to = "customerField", subject = "searchExecutor")
    private List<Customer> customerFieldSearchExecutor(String searchString, Map<String, Object> searchParams) {
        searchValue = searchString;

        return dataManager.load(Customer.class)
                .query("e.name like ?1 order by e.name", "%" + searchString + "%")
                .list();
    }
}